#include<netdb.h>
#include<netinet/in.h>
#include<stdio.h>
#include<strings.h>
#include<string.h>
#include<sys/socket.h>
#include<sys/time.h>
#include<time.h>
#include<unistd.h>
#include<stdlib.h>
#include<errno.h>
#define TPORT 2233

void handle_client(int fd) {
	printf("Kindprozess %d behandelt neue Anfrage.\n", (int)getpid());
	time_t clock; char* tbuf;
	time(&clock); // aktuelle Uhrzeit holen
	tbuf = ctime(&clock); // in String schreiben
	write(fd, tbuf, strlen(tbuf)); // in Clientverbindung schreiben

	while(1) {
		char answerbuf[100];
		int nbytes = read(fd, answerbuf, 99);
		if(nbytes == -1) perror("read"), exit(1);
		if(strncmp("quit", answerbuf, 4) == 0) {
			write(fd, "bye!", 4);
			close(fd);
			break;
		}
	}
}

int main() {
	struct sockaddr_in addr, client_addr; // generische Adressstrukturen
	size_t client_add_len = sizeof(client_addr);
	int sfd, fd; int optval = 1;

	memset(&addr, 0, sizeof(addr));

	addr.sin_family = AF_INET; //TCP/IP-Verbindung
	addr.sin_port = htons(TPORT); // Port eintragen, Network Byte Order

	if((sfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) // socket erzeugen
	perror("socket"), exit(1);

	if(setsockopt(sfd, SOL_SOCKET, SO_REUSEADDR, &optval, sizeof(optval)) < 0)
	perror("setsockopt"), // rasche Wiederzuweisung ermoeglichen
	exit (1);

	if(bind(sfd,(struct sockaddr *)&addr, sizeof(addr)) < 0)
	perror("bind"), exit(1);

	if(listen(sfd, SOMAXCONN) < 0)
	perror("listen"), exit(1);

	printf("concurrenttime listening on port %d\n", TPORT);

	while(1) {
		fd = accept(sfd, (struct sockaddr *) &client_addr, &client_add_len);
		if(fd < 0) {
			if(errno==EINTR) // durch Signal unterbrochen
				continue;
			perror("accept");
			exit(1);
		}
		
		pid_t child = fork();
		if(child < 0) {
			perror("fork");
			close(fd);
			close(sfd);
			exit(1);
		}
		if(child == 0) {
			close(sfd);
			handle_client(fd);
			exit(0);
		}
		close(fd);
	}
	exit(0); // seldomly reached
}
