#include<errno.h>
#include<string.h>
#include<unistd.h>
#include<stdio.h>
#include "inbuf.h"

/* set size of input buffer */

int inbuf_alloc (inbuf* ibuf, unsigned int size) {
	ibuf->pos = 0;
	ibuf->buf = (stralloc) {0};
	return stralloc_ready (&ibuf->buf, size );
}

/* works like read (2) but from ibuf */
ssize_t inbuf_read (inbuf* ibuf, void* buf, size_t size) {
	if(size == 0) return 0;
	if(ibuf->pos >= ibuf->buf.len) {
		if(ibuf->buf.a == 0 && !inbuf_alloc(ibuf, 512)) return -1;
		/* fill input buffer */
		ssize_t nbytes;
		do {
			errno = 0;
			nbytes = read ( ibuf->fd, ibuf->buf.s , ibuf->buf.a );
		} while ( nbytes < 0 && errno == EINTR);
		if (nbytes <= 0) return nbytes;
		ibuf->buf.len = nbytes;
		ibuf->pos = 0;
	}
	ssize_t nbytes = ibuf->buf.len - ibuf->pos;
	if(size<nbytes) nbytes = size ;
	memcpy(buf, ibuf->buf.s + ibuf->pos, nbytes);
	ibuf->pos += nbytes;
	return nbytes;
}

/* give buffer parameters */
int inbuf_pars(inbuf ibuf, int* len, int* a, int* pos) {
	*len = ibuf.buf.len;
	*a = ibuf.buf.a;
	*pos = ibuf.pos;
	return 1;
}

/* works like fgetc but from ibuf */
int inbuf_getchar(inbuf* ibuf) {
	char ch;
	ssize_t nbytes = inbuf_read(ibuf, &ch, sizeof ch);
	if(nbytes <= 0) return -1;
	return ch;
}

/* move backward one position */
int inbuf_back(inbuf* ibuf) {
	if(ibuf->pos == 0) return 0;
	ibuf->pos--;
	return 1;
}

/* release storage associated with ibuf */
void inbuf_free (inbuf* ibuf) {
	stralloc_free(&ibuf->buf);
}

