#ifndef __INBUF_H
#define __INBUF_H
#include<stralloc.h>
#include<unistd.h>

typedef struct inbuf {
	int fd;
	stralloc buf;
	unsigned int pos;
} inbuf ;

/* set size of input buffer */
int inbuf_alloc(inbuf* ibuf, unsigned int size);

/* works like read(2) but from ibuf */
ssize_t inbuf_read(inbuf* ibuf, void* buf, size_t size);

/* give buffer parameters - it's just for demonstration */
int inbuf_pars(inbuf ibuf, int* len, int* a, int* pos);

/* works like fgetc but from ibuf */
int inbuf_getchar(inbuf* ibuf);

/* move backward one position */
int inbuf_back(inbuf* ibuf);

/* release storage associated with ibuf */
void inbuf_free(inbuf* ibuf);

#endif
