#include "readlinecrlf.h"

// readline-Funktion analog zum Tokenizer der tinysh,
// nur mit inbuf* statt einem FILE-Pointer.
// Die Zeile wird durch CR LF (\r\n) beendet.
// Rueckgabewert ist 1 bei Erfolg und 0 sonst
int readlinecrlf(inbuf* buf, stralloc* sa) {
	if (! stralloc_copys ( sa , "" )) return 0; // FALSE
	for (;;) {
		if (! stralloc_readyplus ( sa , 1)) return 0; // FALSE
		if ( inbuf_read (buf , sa->s + sa->len, 1 ) <= 0)
			return 0; // FALSE
		
		if ( sa->s[sa->len] == '\n' && sa->len >= 1 && sa->s[(sa->len)-1] == '\r') {
			--sa->len;
			break;
		}
		++sa->len;
	}
	return 1; // TRUE
}

