#include<sys/types.h>
#include<sys/socket.h>
#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include<stralloc.h>
#include<netdb.h> // gethostbyname
#include<unistd.h>

int main(int argc, char* argv[]) {
	if(argc<3) {
		fprintf(stderr, "Usage: %s hostname port\n", argv[0]);
		exit(255);
	}

	char* hostname = argv[1];
	int port = atoi(argv[2]);

	struct sockaddr_in addr;
	struct hostent* hp;
	int socketfd;

	if(!(hp = gethostbyname(hostname))) {
		fprintf(stderr, "Unbekannter Host: %s", hostname);
		return 0;
	}
	
	// das Adress-Struct ausnullen
	memset(&addr, 0, sizeof(addr));
	addr.sin_family = AF_INET; // TCP/IPv4-Verbindung
	addr.sin_port = htons(port); // Umwandlung in Network Byte Order
	memcpy(&addr.sin_addr, hp->h_addr, hp->h_length); // Adresse kopieren
	
	if((socketfd=socket(AF_INET,SOCK_STREAM,0)) < 0) {
		perror("socket");
		return 0;
	}
	
	if(connect(socketfd, (struct sockaddr*)&addr, sizeof(addr)) == -1) {
		perror("connect");
		return 0;
	}

	/* Ein erster Ansatz waere wie folgt, so kann das aber nicht
	   funktionieren, da read() dann blockiert, bis der Server die
      Verbindung schliesst. */
/*	char readbuf[BUFSIZ];
	int pos = 0;
	while(1) {
		int r = read(socketfd, readbuf, BUFSIZ-pos);
		if(r == -1) perror("read"), exit(1);
		if(r == 0) break;
		write(1, readbuf+pos, r);
		pos += r;
	}*/

	/* Statt dessen lesen wir nur einmal */
	char readbuf[BUFSIZ];
	int r = read(socketfd, readbuf, BUFSIZ);
	if(r == -1) perror("read"), exit(1);
	write(1, readbuf, r);

	srand(time(0)+getpid());
	int sleeptime = 5 + rand()%16;
	printf("Schlafe fuer %d Sekunden.\n", sleeptime);
	sleep(sleeptime);
	printf("Sende quit.\n");
	write(socketfd, "quit\n", 5);
	close(socketfd);
	return 0;
}

